variables:
  DOCKER_DRIVER: overlay

stages:
  - image
  - deploy

build_image:
  stage: image
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN ${CI_REGISTRY}
    - docker build -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA} .
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}

deploy_prod:
  stage: deploy
  services:
    - docker:dind
  image: docker:latest
  script:
    - mkdir -p ~/.docker
    - echo "$TLSCACERT" > ~/.docker/ca.pem
    - echo "$TLSCERT" > ~/.docker/cert.pem
    - echo "$TLSKEY" > ~/.docker/key.pem
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN ${CI_REGISTRY}
    - docker -H tcp://$SWARM_HOST:$SWARM_PORT --tls stack deploy --with-registry-auth -c docker-compose.yml ${CI_PROJECT_NAME}
  only:
    - master
  environment:
    name: prod
    url: http://gap.poptech-devs.ovh
